/* Para o entendimento desde código é necessário ver o exemplo de vetores.

==============================================================================
Posições dos valores da Matriz

matriz[5][5]
 
           coluna 0    coluna 1    coluna 2    coluna 3    coluna 4
        __________________________________________________________________
        |            |            |            |            |            |
linha 0 | posição 00 | posição 01 | posição 02 | posição 03 | posição 04 |
        |____________|____________|____________|____________|____________|
        |            |            |            |            |            |
linha 1 | posição 10 | posição 11 | posição 12 | posição 13 | posição 14 |
        |____________|____________|____________|____________|____________|
        |            |            |            |            |            |
linha 2 | posição 20 | posição 21 | posição 22 | posição 23 | posição 24 |
        |____________|____________|____________|____________|____________|
        |            |            |            |            |            |
linha 3 | posição 30 | posição 31 | posição 32 | posição 33 | posição 34 |
        |____________|____________|____________|____________|____________|
        |            |            |            |            |            |
linha 4 | posição 40 | posição 41 | posição 42 | posição 43 | posição 44 |
        |____________|____________|____________|____________|____________|
 
============================================================================== */

// Declaração das bibliotecas utilizadas
#include <stdio.h>
#include <stdlib.h>

// Definição de constantes para determinar o tamanho da matriz. NxM
#define NUMERO_LINHA 5 // Quantidade de linhas da matriz.
#define NUMERO_COLUNA 5 // Quantidade de colunas da matriz.

// Função para geração de números aleatórios.
// Para a utilização da função rand() utiliza-se a biblioteca <stdlib.h>.
int numero_aleatorio(){
    return rand()% 100;
}

// Função para imprimir a matriz.
// Recebe como parâmetro uma matriz[][].
void imprime_matriz(int matriz[NUMERO_LINHA][NUMERO_COLUNA]){

    int linha, coluna; // Declaração das variáveis.
    
    for (linha = 0; linha < NUMERO_LINHA; linha++){ // Percorre a linha da matriz.
        for (coluna = 0; coluna < NUMERO_COLUNA; coluna++){ // Percorre a coluna da matriz.
            printf("\t%d ", matriz[linha][coluna]); // Imprime o valor da variável da posição matriz[][] da matriz.
        }
        printf("\n\n");
    }
}

// Função para imprimir a diagonal da matriz.
// Recebe como parâmetro uma matriz[][].
void diagonal_principal(int matriz[NUMERO_LINHA][NUMERO_COLUNA]){

    int linha, coluna;
    
    printf("Diagonal Principal\n");
    for (linha = 0; linha < NUMERO_LINHA; linha++){
        for (coluna = 0; coluna < NUMERO_COLUNA; coluna++){
            if (coluna == linha){ // Verifica se a posição da coluna da matriz é igual a posição da linha da matriz.
                printf("\t%d ", matriz[linha][coluna]);
            }else{
                printf("\t");
            }
        }
        printf("\n\n");
    }  
}

// Função para imprimir a matriz triangular inferior da matriz original.
// Recebe como parâmetro uma matriz[][].
void triangular_inferior(int matriz[NUMERO_LINHA][NUMERO_COLUNA]){

    int linha, coluna;

    printf("Matriz triangular inferior\n");
    for (linha = 0; linha < NUMERO_LINHA; linha++){
        for (coluna = 0; coluna < NUMERO_COLUNA; coluna++){
            if (coluna <= linha){ // Verifica se a posição da coluna da matriz é menor ou igual a posição da linha da matriz.
                printf("\t%d ", matriz[linha][coluna]);
            }else{
                printf("\t");
            }
        }
        printf("\n\n");
    }
}

// Função para imprimir a matriz triangular superior da matriz original.
// Recebe como parâmetro uma matriz[][].
void triangular_superior(int matriz[NUMERO_LINHA][NUMERO_COLUNA]){

    int linha, coluna;

    printf("Matriz triangular superior\n");
    for (linha = 0; linha < NUMERO_LINHA; linha++){
        for (coluna = 0; coluna < NUMERO_COLUNA; coluna++){
            if (coluna >= linha){ // Verifica se a posição da coluna da matriz é maior ou igual a posição da linha da matriz.
                printf("\t%d ", matriz[linha][coluna]);
            }else{
                printf("\t");
            }
        }
        printf("\n\n");
    }  
}

int main(void)
  {
      int matriz[NUMERO_LINHA][NUMERO_COLUNA];
      int linha,coluna;

      for(linha = 0;linha < NUMERO_LINHA; linha++){
          for(coluna = 0;coluna < NUMERO_COLUNA; coluna++){
              matriz[linha][coluna] = numero_aleatorio();
          }
      }
      
      imprime_matriz(matriz); // "chamar" função para imprimir a matriz.
      diagonal_principal(matriz); // "chamar" função para imprimir a diagonal principal da matriz.
      triangular_inferior(matriz); // "chamar" função para imprimir o triangular inferior da matriz original.
      triangular_superior(matriz); // "chamar" função para imprimir o triangular superior da matriz original.  
      return 0;
  }
